unit u_net_dbx_briefcase_clientdataset;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBXpress, FMTBcd, Borland.Vcl.Db, Borland.Vcl.SqlExpr,
  Borland.Vcl.StdCtrls, System.ComponentModel, Borland.Vcl.DBClient,
  Borland.Vcl.Provider, Borland.Vcl.Grids, Borland.Vcl.DBGrids,
  Borland.Vcl.ExtCtrls;

type
  TForm2 = class(TForm)
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    Panel3: TPanel;
    Memo1: TMemo;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    load_cds_: TButton;
    save_cds_: TButton;
    display_xml_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure load_cds_Click(Sender: TObject);
    procedure save_cds_Click(Sender: TObject);
    procedure display_xml_Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

    implementation
      uses u_c_net_display, u_c_net_log
          , u_c_net_text_buffer
          , u_c_net_cds_analyze_xml
          , u_c_net_cds_table
          ;

    {$R *.nfm}

    const k_save_dataset_name= '..\_data\save_formation.xml';

    procedure TForm2.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm2.load_cds_Click(Sender: TObject);
      begin
        ClientDataset1.LoadFromFile(k_save_dataset_name);
      end; // load_cds_Click

    procedure TForm2.save_cds_Click(Sender: TObject);
      begin
        ClientDataset1.SaveToFile(k_save_dataset_name);
      end; // save_cds_Click

    procedure TForm2.display_xml_Click(Sender: TObject);
      var l_c_table: c_table;
      begin
        if not FileExists(k_save_dataset_name)
          then display('no '+ k_save_dataset_name);
          
        with c_cds_analyze_xml.create_cds_analyze_xml('xml', k_save_dataset_name) do
        begin
          l_c_table:= c_table.create_table('table');
          analyze_xml(l_c_table);

          display_line;
          l_c_table.display_formatted_line_list;
          l_c_table.Free;
          Free;
        end; // with c_analyze_xml
      end; // display_xml_Click

    procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        ClientDataset1.Close;
      end; // FormClose

end.

